CurTime = 0
OldTime = 0

balls = {}
boxes = {}
--curX = 0
--curY = 0

function love.load()
	ballimg = love.graphics.newImage( "bouncy_ball.png" )
	world = love.physics.newWorld( 0, 0, 800, 600, 0, 500, true )
	world:setMeter( 100 )
	love.graphics.setBackgroundColor( 255, 255, 255 )
end

function love.update( dt )
	CurTime = CurTime + dt
	world:update( dt )
		
	if CurTime >= OldTime+1 then OldTime = CurTime print( CurTime ) end
	for k, v in ipairs( balls ) do	
		if v.body then
			v.x, v.y = v.body:getPosition()
			local velx, vely = v.body:getLinearVelocity()
			if v.body:getX() >= 740 or v.body:getX() <= 60 or v.body:getY() >= 540 or v.body:getY() <= 60 and vx > 50 and vy > 50 then
				--v.body:setPosition( v.x+1, v.y+1 )
				v.body:setLinearVelocity( velx*0.8, vely*-0.8 )
			end
		end
	end
	--if v.body then local x, y = v.body:getLinearVelocity() print("x "..x) print("y "..y) end
end

function love.draw()
	for k, v in ipairs( balls ) do
		if v.body then	
			love.graphics.setColor( v.colr, v.colg, v.colb, 255 )
			love.graphics.draw( ballimg, v.x, v.y, v.body:getAngle(), 2, 2, 0, 0 )
			--if CurTime >= OldTime + 1 then OldTime = CurTime print( "draw "..v ) end
		end
	end
	
	for k, v in ipairs( boxes ) do
		if v.body then	
			local x, y = v.body:getPosition()
			love.graphics.setColor( 0, 0, 0, 255 )
			love.graphics.polygon( "line", v.shape:getPoints() ) --x, y, x+100, y, x+100, y+100, x, y+100 )
			love.graphics.setColor( 255, 0, 0, 255 )
			love.graphics.polygon( "line", x, y, x+100, y, x+100, y+100, x, y+100 )
		end
	end
end
--[[
function love.mousepressed( x, y, button )
	if button == "r" then
		curX = x
		curY = y
	end
end]]

function love.mousereleased( x, y, button )
	if button == "l" then
		local tbl = {}
			tbl.body = love.physics.newBody( world, x, y, 100 )
			--tbl.body:wakeUp()
			tbl.shape = love.physics.newCircleShape( tbl.body, x, y, 16 )
			tbl.colr = math.random( 0, 255 )
			tbl.colg = math.random( 0, 255 )
			tbl.colb = math.random( 0, 255 )							
		table.insert( balls, tbl )
	end
	if button == "r" then
		local tbl = {}
			tbl.body = love.physics.newBody( world, x, y, 0 )
			--tbl.body:wakeUp()
			tbl.shape = love.physics.newRectangleShape( tbl.body, x, y, 100, 100 )							
		table.insert( boxes, tbl )
		local xa, ya = tbl.body:getPosition()
		print( "body x: "..xa.." y: "..ya )
		print( "shape x: "..x.." y: "..y )
	end
end
	